/*
 * Copyright (c) 2018, General Electric
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

////
/// PX-TOGGLE-DESIGN
/// Defines simple toggle objects
/// @group px-toggle-design
////

@import '../px-defaults-design/_settings.defaults.scss';
@import '../px-colors-design/_settings.colors.scss';
@import '../px-helpers-design/_generic.helpers.scss';

/// Prepended namespace for all generated classes.
/// @group px-toggle-design:variables:style
/// @type String [default]
$inuit-toggle-namespace         : $inuit-namespace !default;

/// Toggle background color when checked and enabled.
/// @group px-toggle-design:variables:style
/// @type Color [default]]
/// @todo --px-toggle__background--checked
$inuit-toggle__background--checked              : var(--px-toggle__background--checked, $primary-default);

/// Toggle background color on hover when checked and enabled.
/// @group px-toggle-design:variables:style
/// @type Color [default]]
/// @todo --px-toggle__background--checked--hover
$inuit-toggle__background--checked--hover       : var(--px-toggle__background--checked--hover, $primary-hover);

/// Toggle background color on pressed/active when checked and enabled.
/// @group px-toggle-design:variables:style
/// @type Color [default]]
/// @todo --px-toggle__background--checked--pressed
$inuit-toggle__background--checked--pressed     : var(--px-toggle__background--checked--pressed, $primary-pressed);

/// Toggle background color when checked and disabled.
/// @group px-toggle-design:variables:style
/// @type Color [default]
/// @todo --px-toggle__background--checked--disabled
$inuit-toggle__background--checked--disabled    : var(--px-toggle__background--checked--disabled, rgba($black,0.2));

/// Toggle background color when unchecked and enabled.
/// @group px-toggle-design:variables:style
/// @type Color [default]]
/// @todo --px-toggle__background--unchecked
$inuit-toggle__background--unchecked            : var(--px-toggle__background--unchecked, $gray3);

/// Toggle background color on hover when unchecked and enabled.
/// @group px-toggle-design:variables:style
/// @type Color [default]]
/// @todo --px-toggle__background--unchecked--hover
$inuit-toggle__background--unchecked--hover     : var(--px-toggle__background--unchecked--hover, $gray5);

/// Toggle background color on pressed/active when unchecked and enabled.
/// @group px-toggle-design:variables:style
/// @type Color [default]]
/// @todo --px-toggle__background--unchecked--pressed
$inuit-toggle__background--unchecked--pressed   : var(--px-toggle__background--unchecked--pressed, $gray9);

/// Toggle background color when unchecked and disabled.
/// @group px-toggle-design:variables:style
/// @type Color [default]]
/// @todo --px-toggle__background--unchecked--disabled
$inuit-toggle__background--unchecked--disabled  : var(--px-toggle__background--unchecked--disabled, $white);

/// Toggle border color when unchecked and enabled.
/// @group px-toggle-design:variables:style
/// @type Color [default]
/// @todo --px-toggle__background-border--unchecked
$inuit-toggle__background-border--unchecked     : var(--px-toggle__background-border--unchecked, $gray8);

/// Toggle border color on hover when unchecked and enabled.
/// @group px-toggle-design:variables:style
/// @type Color [default]
/// @todo --px-toggle__background-border--unchecked--hover
$inuit-toggle__background-border--unchecked--hover       : var(--px-toggle__background-border--unchecked--hover, $gray10);

/// Toggle border color on pressed/active when unchecked and enabled.
/// @group px-toggle-design:variables:style
/// @type Color [default]
/// @todo --px-toggle__background-border--unchecked-pressed
$inuit-toggle__background-border--unchecked--pressed     : var(--px-toggle__background-border--unchecked-pressed, $gray12);

/// Toggle border color when unchecked and disabled.
/// @group px-toggle-design:variables:style
/// @type Color [default]
/// @todo --px-toggle__background-border--unchecked--disabled
$inuit-toggle__background-border--unchecked--disabled    : var(--px-toggle__background-border--unchecked--disabled, rgba($black,0.2));

/// Toggle switch color when both checked and unchecked.
/// (The "switch" is the circular part of the toggle.)
/// @group px-toggle-design:variables:style
/// @type Color [default]
/// @todo --px-toggle__switch
$inuit-toggle__switch                      : var(--px-toggle__switch, $white);

/// Toggle switch color on hover when both checked and unchecked.
/// @group px-toggle-design:variables:style
/// @type Color [default]
/// @todo --px-toggle__switch--hover
$inuit-toggle__switch--hover               : var(--px-toggle__switch--hover, $gray4);

/// Toggle switch color on pressed/active when both checked and unchecked.
/// @group px-toggle-design:variables:style
/// @type Color [default]
/// @todo --px-toggle__switch--pressed
$inuit-toggle__switch--pressed             : var(--px-toggle__switch--pressed, $gray7);

/// Toggle switch color on disabled when both checked and unchecked.
/// @group px-toggle-design:variables:style
/// @type Color [default]
/// @todo --px-toggle__switch--disabled
$inuit-toggle__switch--disabled            : var(--px-toggle__switch--disabled, $white);

/// Toggle switch border color when both checked and unchecked.
/// @group px-toggle-design:variables:style
/// @type Color [default]
/// @todo --px-toggle__switch-border
$inuit-toggle__switch-border               : var(--px-toggle__switch-border, $gray8);

/// Toggle switch border color on hover when both checked and unchecked.
/// @group px-toggle-design:variables:style
/// @type Color [default]
/// @todo --px-toggle__switch-border--hover
$inuit-toggle__switch-border--hover        : var(--px-toggle__switch-border--hover, $gray8);

/// Toggle switch border color on pressed/active when both checked and unchecked.
/// @group px-toggle-design:variables:style
/// @type Color [default]
/// @todo --px-toggle__switch-border--pressed
$inuit-toggle__switch-border--pressed      : var(--px-toggle__switch-border--pressed, $gray8);

/// Toggle switch border color on disabled when both checked and unchecked.
/// @group px-toggle-design:variables:style
/// @type Color [default]
/// @todo --px-toggle__switch-border--disabled
$inuit-toggle__switch-border--disabled     : var(--px-toggle__switch-border--disabled, rgba($black,0.2));

/// Toggle switch shadow color.
/// @group px-toggle-design:variables:style
/// @type Color | String [default]
/// @todo --px-toggle__switch-shadow-color
$inuit-toggle__switch-shadow               : 0px 1px 2px var(--px-toggle__switch-shadow-color, rgba($black, .15));

/// Generates the CSS for small toggles if enabled.
/// @group px-toggle-design:variables:flag
/// @type Boolean [default]
$inuit-enable-toggle--small     : false !default;

/// Generates the CSS for large toggles if enabled.
/// @group px-toggle-design:variables:flag
/// @type Boolean [default]
$inuit-enable-toggle--large     : false !default;

/// Generates the CSS for huge toggles if enabled.
/// @group px-toggle-design:variables:flag
/// @type Boolean [default]
$inuit-enable-toggle--huge      : false !default;

/// Generates the CSS for disabled toggles if enabled.
/// @group px-toggle-design:variables:flag
/// @type Boolean [default]
$inuit-enable-toggle--disabled   : false !default;

/**
 * Enabled toggle
 */
.#{$inuit-toggle-namespace}toggle__input,
%#{$inuit-toggle-namespace}toggle__input {
  @include accessibility;
  &:checked + {
    .#{$inuit-toggle-namespace}toggle__label,
    %#{$inuit-toggle-namespace}toggle__label {
      background-color: $inuit-toggle__background--checked;
      &:before {
        background-color: $inuit-toggle__background--checked;
      }
      &:hover:before{
        background-color: $inuit-toggle__background--checked--hover;
      }
      &:hover {
        background-color: $inuit-toggle__background--checked--hover;
      }
      &:active:before {
        background-color: $inuit-toggle__background--checked--pressed;
      }
      &:active {
        background-color: $inuit-toggle__background--checked--pressed;
      }
      &:after {
        margin-left: 1.467rem //22px
      }
    }
  }
}

.#{$inuit-toggle-namespace}toggle__label,
%#{$inuit-toggle-namespace}toggle__label {
  position: relative;
  display: block;
  width: $inuit-base-spacing-unit--large * 2;
  min-width: $inuit-base-spacing-unit--large * 2;
  height: calc(#{$inuit-base-spacing-unit} - 1px);
  border-radius: $inuit-base-spacing-unit--huge;
  margin-bottom: 0;
  margin-left: 0;
  padding: 1px;
  cursor: pointer;
  outline: none;
  user-select: none;
  transition: background .4s;
  background-color: $inuit-toggle__background-border--unchecked;
  text-indent: -9999rem;
  pointer-events: auto;
  &:before, &:after {
    position: absolute;
    display: block;
    content: "";
  }
  &:before {
    top: 1px;
    right: 1px;
    bottom: 1px;
    left: 1px;
    border-radius: $inuit-base-spacing-unit--huge;
    transition: background .4s;
    background-color: $inuit-toggle__background--unchecked;
  }
  &:hover:before {
    background-color: $inuit-toggle__background--unchecked--hover;
  }
  &:hover {
    background-color: $inuit-toggle__background-border--unchecked--hover;
  }
  &:active:before {
    background-color: $inuit-toggle__background--unchecked--pressed;
  }
  &:active {
    background-color: $inuit-toggle__background-border--unchecked--pressed;
  }
  &:after {
    top: -3px;
    left: -1px;
    height: $inuit-base-spacing-unit--large;
    width: $inuit-base-spacing-unit--large;
    border: 1px solid $inuit-toggle__switch-border;
    border-radius: 50%;
    box-shadow: $inuit-toggle__switch-shadow;
    background-color: $inuit-toggle__switch;
    transition: margin .4s, background .4s, border-color .4s;
  }
  &:hover:after {
    background-color: $inuit-toggle__switch--hover;
    border: 1px solid $inuit-toggle__switch-border--hover;
  }
  &:active:after {
    background-color: $inuit-toggle__switch--pressed;
    border: 1px solid $inuit-toggle__switch-border--pressed;
  }
}

/**
  * Disabled toggle
  */
@if ($inuit-enable-toggle--disabled == true) {

  .#{$inuit-toggle-namespace}toggle__input,
  %#{$inuit-toggle-namespace}toggle__input {
    &:checked + {
      .#{$inuit-toggle-namespace}toggle--disabled,
      %#{$inuit-toggle-namespace}toggle--disabled
      .toggle__label[disabled] {
        background-color: $inuit-toggle__background--checked--disabled;
        &:before {
          background-color: transparent;
        }
        &:after {
          box-shadow: none;
          background-color: $inuit-toggle__switch--disabled;
          border-width: 1px;
          border-style: solid;
          border-color: $inuit-toggle__switch-border--disabled;
        }
      }
    }
  }
  .#{$inuit-toggle-namespace}toggle--disabled,
  %#{$inuit-toggle-namespace}toggle--disabled,
  .toggle__label[disabled] {
    background-color: $inuit-toggle__background-border--unchecked--disabled;
    pointer-events: none;
    &:before {
      background-color: $inuit-toggle__background--unchecked--disabled;
      box-shadow: none;
    }
    &:after {
      box-shadow: none;
      background-color: $inuit-toggle__switch--disabled;
      border-width: 1px;
      border-style: solid;
      border-color: $inuit-toggle__switch-border--disabled;
    }
  }
}

/**
  * Small toggle
  */
@if ($inuit-enable-toggle--small == true) {

  .#{$inuit-toggle-namespace}toggle__input--small,
  %#{$inuit-toggle-namespace}toggle__input--small {
    &:checked + {
      .#{$inuit-toggle-namespace}toggle__label--small,
      %#{$inuit-toggle-namespace}toggle__label--small {
        &:after {
          margin-left: $inuit-base-spacing-unit;
        }
      }
    }
  }
  .#{$inuit-toggle-namespace}toggle__label--small,
  %#{$inuit-toggle-namespace}toggle__label--small {
    width: $inuit-base-spacing-unit--huge;
    min-width: $inuit-base-spacing-unit--huge;
    height: calc(#{$inuit-base-spacing-unit--small} + 1px);
    &:after {
      top: -2px;
      left: 0px;
      height: $inuit-base-spacing-unit;
      width: $inuit-base-spacing-unit;
    }
  }

}

/**
  * Large toggle
  */
@if ($inuit-enable-toggle--large == true) {

  .#{$inuit-toggle-namespace}toggle__input--large,
  %#{$inuit-toggle-namespace}toggle__input--large {
    &:checked + {
      .#{$inuit-toggle-namespace}toggle__label--large,
      %#{$inuit-toggle-namespace}toggle__label--large {
        &:after {
          margin-left: 2.133rem; //32px
        }
      }
    }
  }
  .#{$inuit-toggle-namespace}toggle__label--large,
  %#{$inuit-toggle-namespace}toggle__label--large {
    width: $inuit-base-spacing-unit--huge * 2;
    min-width: $inuit-base-spacing-unit--huge * 2;
    height: $inuit-base-spacing-unit--large;
    &:after {
      top: calculateRem(-5px);
      left: calculateRem(-1px);
      height: $inuit-base-spacing-unit--huge;
      width: $inuit-base-spacing-unit--huge;
    }
  }

}



/**
  * Huge toggle
  */
@if ($inuit-enable-toggle--huge == true) {

  .#{$inuit-toggle-namespace}toggle__input--huge,
  %#{$inuit-toggle-namespace}toggle__input--huge {
    &:checked + {
      .#{$inuit-toggle-namespace}toggle__label--huge,
      %#{$inuit-toggle-namespace}toggle__label--huge {
        &:after {
          margin-left: 2.8rem //42px
        }
      }
    }
  }
  .#{$inuit-toggle-namespace}toggle__label--huge,
  %#{$inuit-toggle-namespace}toggle__label--huge {
    width: $inuit-base-spacing-unit--large * 4;
    min-width: $inuit-base-spacing-unit--large * 4;
    height: $inuit-base-spacing-unit--huge;
    &:before {
    }
    &:after {
      top: calculateRem(-5px);
      left: calculateRem(-1px);
      height: calc(#{$inuit-base-spacing-unit--large * 2});
      width: calc(#{$inuit-base-spacing-unit--large * 2});
    }
  }

}
